/* drawing (DXF) to G-code (NGC) converter
 * Copyright 2013 Stefan Schuermans <stefan@schuermans.info>
 * Copyleft: CC-BY-SA http://creativecommons.org/licenses/by-sa/3.0/
 */

#ifndef TRAVERSE_H
#define TRAVERSE_H

#include <dime/entities/Entity.h>
#include <dime/State.h>

#include "drawing.h"

/// context structure for traverse entities callback
struct traverse_ctx {
  Drawing *mpDrawing; ///< the drawing to add the entities to
};

/**
 * @brief process an entity during DXF traversal
 * @param[in] state current state of libdime
 * @param[in] entity pointer to entity
 * @param[in] vp_ctx context pointer, must point to traverse_ctx structure
 * @return if to continue enumeration
 */
bool traverse_entity(const class dimeState * const state, dimeEntity *entity,
                     void *vp_ctx);

#endif // #ifndef TRAVERSE_H

